<template>
  <div class="container">
    <div class="row">
      <div class="col-sm-10">
        <h1>Vuejs client: Bases<br><small>{{ bases.length }} items</small></h1>
        <hr><br>
        <alert :message="message" v-if="showMessage"></alert>
        <button type="button" class="btn btn-success btn-sm" v-b-modal.base-modal>Add Base</button>
        <br><br>
        <table class="table table-hover">
          <thead>
            <tr>
              <th scope="col">Public id</th>
              <th scope="col">Type</th>
              <th scope="col">Preview</th>
              <th scope="col">Active?</th>
              <th></th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="(base, index) in bases" :key="index">
              <td>{{ base.public_id  }}</td>
              <td>{{ base.type  }}</td>
              <td><img :src="base.preview" width="50px"/><br>{{ base.preview }}</td>
              <td>
                <span v-if="base.active">Yes</span>
                <span v-else>No</span>
              </td>
              <td>
                <div class="btn-group" role="group">
                  <button type="button"
                          class="btn btn-warning btn-sm"
                          v-b-modal.base-update-modal
                          @click="editBaseForm(base)">
                      Edit
                  </button>
                  <button type="button"
                          class="btn btn-danger btn-sm"
                          @click="onDeleteBase(base)">
                      Delete
                  </button>
                </div>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
    <b-modal ref="addBaseModal"
         id="base-modal"
         title="Add a new base"
         hide-footer>
  <b-form @submit="onSubmit" @reset="onReset" class="w-100">
  <b-form-group id="form-type-group"
                label="Type:"
                label-for="form-type-input">
      <b-form-input id="form-type-input"
                    type="text"
                    v-model="addBaseForm.type"
                    required
                    placeholder="Enter type">
      </b-form-input>
    </b-form-group>
    <b-form-group id="form-preview-group"
                  label="Preview:"
                  label-for="form-preview-input">
        <b-form-input id="form-preview-input"
                      type="text"
                      v-model="addBaseForm.preview"
                      required
                      placeholder="Enter preview">
        </b-form-input>
      </b-form-group>
    <b-form-group id="form-active-group">
      <b-form-checkbox-group v-model="addBaseForm.active" id="form-checks">
        <b-form-checkbox value="true">Active?</b-form-checkbox>
      </b-form-checkbox-group>
    </b-form-group>
    <b-button type="submit" variant="primary">Submit</b-button>
    <b-button type="reset" variant="danger">Reset</b-button>
  </b-form>
</b-modal>
<b-modal ref="editBaseModal"
         id="base-update-modal"
         title="Update"
         hide-footer>
  <b-form @submit="onSubmitUpdate" @reset="onResetUpdate" class="w-100">
  <b-form-group id="form-type-edit-group"
                label="Type:"
                label-for="form-type-edit-input">
      <b-form-input id="form-type-edit-input"
                    type="text"
                    v-model="editForm.type"
                    required
                    placeholder="Enter type">
      </b-form-input>
    </b-form-group>
    <b-form-group id="form-preview-edit-group"
                  label="Preview:"
                  label-for="form-preview-edit-input">
        <b-form-input id="form-preview-edit-input"
                      type="text"
                      v-model="editForm.preview"
                      required
                      placeholder="Enter preview">
        </b-form-input>
      </b-form-group>
    <b-form-group id="form-active-edit-group">
      <b-form-checkbox-group v-model="editForm.active" id="form-checks">
        <b-form-checkbox value="true">Active?</b-form-checkbox>
      </b-form-checkbox-group>
    </b-form-group>
    <b-button-group>
      <b-button type="submit" variant="primary">Update</b-button>
      <b-button type="reset" variant="danger">Cancel</b-button>
    </b-button-group>
  </b-form>
</b-modal>
  </div>
</template>

<script>
import axios from 'axios';
import Alert from './Alert.vue';

export default {
  data() {
    return {
      bases: [],
      addBaseForm: {
        type: '',
        preview: '',
        active: [],
      },
      editForm: {
        id: '',
        type: '',
        preview: '',
        active: [],
      },
      message: '',
      showMessage: false,
    };
  },
  components: {
    alert: Alert,
  },
  methods: {
    getBases() {
      const path = 'http://localhost:5000/bases';
      // Query params
      /*
      const keywords = '';
      const filter_dict = {};
      const order = 'asc';
      const sort_on = '';
      const current_page = 1;
      const per_page = 10;
      const offset = 0;
      */
      axios.get(path)
        .then((res) => {
          this.bases = res.data.data.data;
        })
        .catch((error) => {
          // eslint-disable-next-line
          console.error(error);
        });
    },
    addBase(payload) {
      const path = 'http://localhost:5000/bases';
      axios.post(path, payload)
        .then(() => {
          this.getBases();
          this.message = 'Base added!';
          this.showMessage = true;
        })
        .catch((error) => {
          // eslint-disable-next-line
          console.log(error);
          this.getBases();
        });
    },
    updateBase(payload, baseID) {
      const path = `http://localhost:5000/bases/${baseID}`;
      axios.put(path, payload)
        .then(() => {
          this.getBases();
          this.message = 'Base updated!';
          this.showMessage = true;
        })
        .catch((error) => {
          // eslint-disable-next-line
          console.error(error);
          this.getBases();
        });
    },
    removeBase(baseID) {
      const path = `http://localhost:5000/bases/${baseID}`;
      axios.delete(path)
        .then(() => {
          this.getBases();
          this.message = 'Base removed!';
          this.showMessage = true;
        })
        .catch((error) => {
          // eslint-disable-next-line
          console.error(error);
          this.getBases();
        });
    },
    initForm() {
      this.addBaseForm.type = '';
      this.addBaseForm.preview = '';
      this.addBaseForm.active = [];
      this.editForm.public_id = '';
      this.editForm.type = '';
      this.editForm.preview = '';
      this.editForm.active = [];
    },
    editBaseForm(base) {
      this.editForm = base;
    },
    onResetUpdate(evt) {
      evt.preventDefault();
      this.$refs.editBaseModal.hide();
      this.initForm();
      this.getBases(); // why?
    },
    onDeleteBase(base) {
      this.removeBase(base.public_id);
    },
    onSubmitUpdate(evt) {
      evt.preventDefault();
      this.$refs.editBaseModal.hide();
      let active = false;
      if (this.editForm.active[0]) active = true;
      const payload = {
        type: this.editForm.type,
        preview: this.editForm.preview,
        active,
      };
      this.updateBase(payload, this.editForm.public_id);
    },
    onSubmit(evt) {
      evt.preventDefault();
      this.$refs.addBaseModal.hide();
      let active = false;
      if (this.addBaseForm.active[0]) active = true;
      const payload = {
        type: this.addBaseForm.type,
        preview: this.addBaseForm.preview,
        active, // property shorthand
      };
      this.addBase(payload);
      this.initForm();
    },
    onReset(evt) {
      evt.preventDefault();
      this.$refs.addBaseModal.hide();
      this.initForm();
    },
  },
  created() {
    this.getBases();
  },
};
</script>
